﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using SGA.Models;
using Insya.Localization;

namespace SGA.Controllers
{
    public class FormatosController : BaseController
    {
        private ARTF formato = new ARTF();

        public ActionResult Index()
        {
            return View(formato.Listar());
        }

        public ActionResult Crud(string codigo = null, decimal nFormato = 0)
        {
            formato.sARTF_CODIGO = codigo;
            return View(codigo != null & nFormato != 0 ? formato.Obtener(codigo, nFormato) : formato);
        }

        //Ver los detalles de un formato
        public ActionResult Ver(string codigo, decimal nFormato)
        {
            return View(formato.Obtener(codigo, nFormato));
        }


        //Guardar los cambios
        public ActionResult Guardar(ARTF formato)
        {
            if (ModelState.IsValid)
            {
                try
                {
                    formato.Guardar();
                    return Redirect("~/articulos/ver/" + formato.sARTF_CODIGO);
                }
                catch (Exception)
                {
                    formato.iARTF_NFORMATO = 0;
                    ModelState.AddModelError("", Localization.Localize("excepcionCreacion")); //adicionar mensaje de error al modelo
                    return View("~/Views/formatos/Crud.cshtml", formato);
                }

            }
            else
            {
                return View("~/Views/formatos/Crud.cshtml", formato);
            }
            
        }

        public ActionResult Eliminar(string codigo = null, decimal nFormato = 0)
        {
            formato.Eliminar(codigo,nFormato);
            return Redirect("~/articulos/ver/" + codigo);
        }
    }
}
