﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using SGA.Models;
using System.Web.Security;

namespace SGA.Controllers
{
    public class HomeController : BaseController
    {
        private ENTU entradasUsuario = new ENTU();
        private SALU salidasUsuario = new SALU();
        private HSAC salidasHistorico = new HSAC();
        private HENC entradasHistorico = new HENC();

        // GET: Home
        public ActionResult Index()
        {
            if (Session["LogedUserID"] != null)
            {
                PedidosModel pm = new PedidosModel();
                pm.EntradasAsignadas = entradasUsuario.Listar();
                pm.SalidasAsignadas = salidasUsuario.Listar();
                pm.EntradasHistorico = entradasHistorico.Listar();
                pm.SalidasHistorico = salidasHistorico.Listar();
                return View(pm);
            }
            else
            {
                return RedirectToAction("Login", "User");
            }
           
        }

        //ver Historico entrada
        public ActionResult VerHistoricoE(int codigo)
        {
            return View(entradasHistorico.Obtener(codigo));
        }

        //Ver historico salida
        public ActionResult VerHistoricoS(int codigo)
        {
            return View(salidasHistorico.Obtener(codigo));
        }

        // Index terminales
        public ActionResult IndexT()
        {
            if (Session["LogedUserID"] != null)
            {
                PedidosModel pm = new PedidosModel();
                pm.EntradasAsignadas = entradasUsuario.ListarByUser(Session["LogedUserFullname"].ToString());
                pm.SalidasAsignadas = salidasUsuario.ListarByUser(Session["LogedUserFullname"].ToString());
                return View(pm);
            }
            else
            {
                return RedirectToAction("Login", "User");
            }

        }


        //public ActionResult ChangeCurrentCulture(int culture)
        //{
        //    //
        //    // Change the current culture for this user.
        //    //
        //    System.Threading.Thread.CurrentThread.CurrentUICulture = new System.Globalization.CultureInfo("es-ES");
        //    //
        //    // Cache the new current culture into the user HTTP session. 
        //    //
        //    Session["CurrentUICulture"] = culture;
        //    //
        //    // Redirect to the same page from where the request was made! 
        //    //
        //    return Redirect(Request.UrlReferrer.ToString());
        //}
    }
}