﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using SGA.Models;
using System.ComponentModel.DataAnnotations;
using Insya.Localization;
using Insya.Localization.Attributes;

namespace SGA.Controllers
{
    public enum TipoZonasEspeciales
    {
        MuelleCarga = 1,
        MuelleDescarga = 2,
        MuelleCargaDescarga = 3
    }

    public class ZonasController : BaseController
    {
        private ZONA zona = new ZONA();
        // GET: Zonas
        public ActionResult Index()
        {
            ZonasModel zonas = new ZonasModel();
            zonas.MuellesCarga = zona.ListarTipo((int)TipoZonasEspeciales.MuelleCarga);
            zonas.MuellesDescarga= zona.ListarTipo((int)TipoZonasEspeciales.MuelleDescarga);
            zonas.MuellesCargaDescarga = zona.ListarTipo((int)TipoZonasEspeciales.MuelleCargaDescarga);
            zona.Listar();
            return View(zonas);
        }

        public ActionResult Crud(int id = 0)
        {
            return View(id != 0 ? zona.Obtener(id) : zona);
        }

        /// <summary>
        /// Guarda el usuario recibido desde el formulario de creación de usuarios
        /// </summary>
        /// <param name="userProfile"></param>
        /// <returns></returns>
        public ActionResult Guardar(ZONA zone)
        {
            if (ModelState.IsValid)
            {
                try
                {
                    zone.Guardar();
                    return Redirect("~/zonas");
                }
                catch (Exception)
                {
                    ModelState.AddModelError("", Localization.Localize("excepcionCreacion")); //adicionar mensaje de error al modelo
                    return View("~/Views/Zonas/Crud.cshtml", zone);
                }

            }
            else
            {
                return View("~/Views/Zonas/Crud.cshtml", zone);
            }

        }

        /// <summary>
        /// Eliminar usuarios
        /// </summary>
        /// <param name="user"></param>
        /// <returns></returns>
        public ActionResult Eliminar(string codigo, int tipo)
        {
            zona.Eliminar(codigo,tipo);
            return Redirect("~/zonas");
        }

    }
}