namespace SGA.Models
{
    using Insya.Localization.Attributes;
    using System;
    using System.Collections.Generic;
    using System.ComponentModel.DataAnnotations;
    using System.ComponentModel.DataAnnotations.Schema;
    using System.Data.Entity.Spatial;
    using System.Linq;
    [Table("ENTL")]
    public partial class ENTL
    {
        public int id { get; set; }

        public int sENTL_IDENTRADA { get; set; }

        [RequiredLocalized]
        public string sENTL_CODARTICULO { get; set; }

        [Column(TypeName = "numeric")]
        [DisplayFormat(DataFormatString = "{0}")]
        public decimal sENTL_EAN { get; set; }

        [RequiredLocalized]
        [DisplayFormat(DataFormatString = "{0}")]
        [Column(TypeName = "numeric")]
        public decimal sENTL_CANTIDAD { get; set; }

        [DisplayFormat(DataFormatString = "{0}")]
        [Column(TypeName = "numeric")]
        public decimal sENTL_FORMATO { get; set; }

        public virtual ENTC ENTC { get; set; }

        public List<ENTL> Listar()
        {
            var lineas = new List<ENTL>();
            try
            {
                using (var context = new SGAContext())
                {
                    lineas = context.ENTL.ToList();
                }
            }
            catch (Exception e)
            {
                throw new Exception(e.Message);
            }
            return lineas;
        }

        public ENTL Obtener(int idEntrada, int codigo)
        {
            var linea = new ENTL();
            try
            {
                using (var context = new SGAContext())
                {
                    linea = context.ENTL
                        .Where(x => x.id == codigo && x.sENTL_IDENTRADA==idEntrada)
                        .Single();
                }
            }
            catch (Exception e)
            {
                throw new Exception(e.Message);
            }
            return linea;
        }

        public void Guardar()
        {
            try
            {
                using (var context = new SGAContext())
                {
                    if (this.id == 0)
                    {
                        context.Entry(this).State = System.Data.Entity.EntityState.Added;
                    }
                    else
                    {
                        context.Entry(this).State = System.Data.Entity.EntityState.Modified;
                    }

                    context.SaveChanges();
                }
            }
            catch (Exception e)
            {
                throw new Exception(e.Message);
            }
        }

        public void Eliminar(int idEntrada = 0, int codigo = 0)
        {
            try
            {
                using (var context = new SGAContext())
                {
                    context.Entry(new ENTL { id = codigo , sENTL_IDENTRADA=idEntrada}).State = System.Data.Entity.EntityState.Deleted;
                    context.SaveChanges();
                }
            }
            catch (Exception e)
            {
                throw new Exception(e.Message);
            }
        }
    }
}
