namespace SGA.Models
{
    using System;
    using System.Collections.Generic;
    using System.ComponentModel.DataAnnotations;
    using System.ComponentModel.DataAnnotations.Schema;
    using System.Data.Entity.Spatial;
    using System.Linq;

    [Table("HENC")]
    public partial class HENC
    {
        [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Usage", "CA2214:DoNotCallOverridableMethodsInConstructors")]
        public HENC()
        {
            HENL = new HashSet<HENL>();
        }

        [DatabaseGenerated(DatabaseGeneratedOption.None)]
        public int id { get; set; }

        [StringLength(50)]
        public string sHENC_NPEDIDO { get; set; }

        public DateTime dHENC_FECHA { get; set; }

        public DateTime? dHENC_FINICIO { get; set; }

        public DateTime? dHENC_FFIN { get; set; }

        public string sHENC_PROVEEDOR { get; set; }

        public string sHENC_TRANSPORTISTA { get; set; }

        public bool bHENC_AUTOMATICO { get; set; }

        [Required]
        public string sHENC_USUARIO { get; set; }

        [Column(TypeName = "numeric")]
        public decimal sHENC_PRIORIDAD { get; set; }

        [StringLength(50)]
        public string sHENC_NALBARAN { get; set; }

        [StringLength(50)]
        public string sHENC_MUELLE { get; set; }

        public DateTime dHENC_FINICIOREAL { get; set; }

        public DateTime dHENC_FFINREAL { get; set; }

        [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Usage", "CA2227:CollectionPropertiesShouldBeReadOnly")]
        public virtual ICollection<HENL> HENL { get; set; }

        public List<HENC> Listar()
        {
            var entradas = new List<HENC>();
            try
            {
                using (var context = new SGAContext())
                {
                    entradas = context.HENC
                        .Include("HENL")
                        .ToList();
                }
            }
            catch (Exception e)
            {
                throw new Exception(e.Message);
            }
            return entradas;
        }

        public HENC Obtener(int codigo)
        {
            var entrada = new HENC();
            try
            {
                using (var context = new SGAContext())
                {
                    entrada = context.HENC
                        .Include("HENL")
                        .Where(x => x.id == codigo)
                        .Single();
                }
            }
            catch (Exception e)
            {
                throw new Exception(e.Message);
            }
            return entrada;
        }

        public void Guardar()
        {
            try
            {
                using (var context = new SGAContext())
                {
                    context.Entry(this).State = System.Data.Entity.EntityState.Added;
                    context.SaveChanges();
                }
            }
            catch (Exception e)
            {
                throw new Exception(e.Message);
            }
        }
    }
}
