namespace SGA.Models
{
    using System;
    using System.Collections.Generic;
    using System.ComponentModel.DataAnnotations;
    using System.ComponentModel.DataAnnotations.Schema;
    using System.Data.Entity.Spatial;
    using System.Linq;

    [Table("HSAC")]
    public partial class HSAC
    {
        [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Usage", "CA2214:DoNotCallOverridableMethodsInConstructors")]
        public HSAC()
        {
            HSAL = new HashSet<HSAL>();
        }

        [DatabaseGenerated(DatabaseGeneratedOption.None)]
        public int id { get; set; }

        [StringLength(50)]
        public string sHSAC_NPEDIDO { get; set; }

        public DateTime dHSAC_FECHA { get; set; }

        public DateTime? dHSAC_FINICIO { get; set; }

        public DateTime? dHSAC_FFIN { get; set; }

        public string sHSAC_CLIENTE { get; set; }

        public string sHSAC_TRANSPORTISTA { get; set; }

        public bool bHSAC_AUTOMATICO { get; set; }

        [Required]
        public string sHSAC_USUARIO { get; set; }

        [Column(TypeName = "numeric")]
        public decimal sHSAC_PRIORIDAD { get; set; }

        [StringLength(50)]
        public string sHSAC_NALBARAN { get; set; }

        [StringLength(50)]
        public string sHSAC_MUELLEPLAYA { get; set; }

        public DateTime? dHSAC_FINICIOREAL { get; set; }

        public DateTime? dHSAC_FFINREAL { get; set; }

        [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Usage", "CA2227:CollectionPropertiesShouldBeReadOnly")]
        public virtual ICollection<HSAL> HSAL { get; set; }

        public List<HSAC> Listar()
        {
            var salidas = new List<HSAC>();
            try
            {
                using (var context = new SGAContext())
                {
                    salidas = context.HSAC
                        .Include("HSAL")
                        .ToList();
                }
            }
            catch (Exception e)
            {
                throw new Exception(e.Message);
            }
            return salidas;
        }

        public HSAC Obtener(int codigo)
        {
            var salida = new HSAC();
            try
            {
                using (var context = new SGAContext())
                {
                    salida = context.HSAC
                        .Include("HSAL")
                        .Where(x => x.id == codigo)
                        .Single();
                }
            }
            catch (Exception e)
            {
                throw new Exception(e.Message);
            }
            return salida;
        }

        public void Guardar()
        {
            try
            {
                using (var context = new SGAContext())
                {
                    context.Entry(this).State = System.Data.Entity.EntityState.Added;
                    context.SaveChanges();
                }
            }
            catch (Exception e)
            {
                throw new Exception(e.Message);
            }
        }
    }
}
