namespace SGA.Models
{
    using Insya.Localization.Attributes;
    using System;
    using System.Collections.Generic;
    using System.ComponentModel.DataAnnotations;
    using System.ComponentModel.DataAnnotations.Schema;
    using System.Data.Entity.Spatial;
    using System.Linq;
    [Table("SALL")]
    public partial class SALL
    {
        public int id { get; set; }

        public int sSALL_IDSALIDA { get; set; }

        [RequiredLocalized]
        public string sSALL_CODARTICULO { get; set; }

        [Column(TypeName = "numeric")]
        [DisplayFormat(DataFormatString = "{0}")]
        public decimal sSALL_EAN { get; set; }

        [RequiredLocalized]
        [Column(TypeName = "numeric")]
        [DisplayFormat(DataFormatString = "{0}")]
        public decimal sSALL_CANTIDAD { get; set; }

        [Column(TypeName = "numeric")]
        [DisplayFormat(DataFormatString = "{0}")]
        public decimal sSALL_FORMATO { get; set; }

        public bool bSALL_DISPONIBLE { get; set; }

        public virtual SALC SALC { get; set; }

        public List<SALL> Listar()
        {
            var lineas = new List<SALL>();
            try
            {
                using (var context = new SGAContext())
                {
                    lineas = context.SALL.ToList();
                }
            }
            catch (Exception e)
            {
                throw new Exception(e.Message);
            }
            return lineas;
        }

        public SALL Obtener(int idSalida, int codigo)
        {
            var linea = new SALL();
            try
            {
                using (var context = new SGAContext())
                {
                    linea = context.SALL
                        .Where(x => x.id == codigo && x.sSALL_IDSALIDA==idSalida)
                        .Single();
                }
            }
            catch (Exception e)
            {
                throw new Exception(e.Message);
            }
            return linea;
        }

        public void Guardar()
        {
            try
            {
                using (var context = new SGAContext())
                {
                    if (this.id == 0)
                    {
                        context.Entry(this).State = System.Data.Entity.EntityState.Added;
                    }
                    else
                    {
                        context.Entry(this).State = System.Data.Entity.EntityState.Modified;
                    }

                    context.SaveChanges();
                }
            }
            catch (Exception e)
            {
                throw new Exception(e.Message);
            }
        }

        public void Eliminar(int idSalida = 0, int codigo = 0)
        {
            try
            {
                using (var context = new SGAContext())
                {
                    context.Entry(new SALL { id = codigo , sSALL_IDSALIDA=idSalida}).State = System.Data.Entity.EntityState.Deleted;
                    context.SaveChanges();
                }
            }
            catch (Exception e)
            {
                throw new Exception(e.Message);
            }
        }
    }
}
