namespace SGA.Models
{
    using System;
    using System.Collections.Generic;
    using System.ComponentModel.DataAnnotations;
    using System.ComponentModel.DataAnnotations.Schema;
    using System.Data.Entity.Spatial;
    using System.Linq;

    [Table("UBCA")]
    public partial class UBCA
    {
        [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Usage", "CA2214:DoNotCallOverridableMethodsInConstructors")]
        public UBCA()
        {
            UBCZ = new HashSet<UBCZ>();
        }

        [DatabaseGenerated(DatabaseGeneratedOption.Identity)]
        public int id { get; set; }

        [Key]
        [StringLength(2)]
        public string sUBCA_ALMACEN { get; set; }

        public List<UBCA> Listar()
        {
            var almacenes = new List<UBCA>();
            try
            {
                using (var context = new SGAContext())
                {
                    almacenes = context.UBCA.ToList();
                }
            }
            catch (Exception e)
            {
                throw new Exception(e.Message);
            }
            return almacenes;
        }

        public string ObtenerMax()
        {
            var idMax = string.Empty;
            try
            {
                using (var context = new SGAContext())
                {
                    idMax = context.UBCA.
                        Max(x => x.sUBCA_ALMACEN);
                }
            }
            catch (Exception e)
            {
                throw new Exception(e.Message);
            }
            return idMax;
        }

        public void Guardar()
        {
            try
            {
                using (var context = new SGAContext())
                {
                    if (this.id == 0)
                    {
                        context.Entry(this).State = System.Data.Entity.EntityState.Added;
                    }
                    else
                    {
                        context.Entry(this).State = System.Data.Entity.EntityState.Modified;
                    }

                    context.SaveChanges();
                }
            }
            catch (Exception e)
            {
                throw new Exception(e.Message);
            }
        }

        [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Usage", "CA2227:CollectionPropertiesShouldBeReadOnly")]
        public virtual ICollection<UBCZ> UBCZ { get; set; }
    }
}
