namespace SGA.Models
{
    using Insya.Localization.Attributes;
    using System;
    using System.Collections.Generic;
    using System.ComponentModel.DataAnnotations;
    using System.ComponentModel.DataAnnotations.Schema;
    using System.Data.Entity.Spatial;
    using System.Linq;

    [Table("UBCI")]
    public partial class UBCI
    {
        public int id { get; set; }

        [RequiredLocalized]
        [StringLength(4)]
        public string sUBCI_ALMACEN { get; set; }

        [RequiredLocalized]
        [StringLength(2)]
        public string sUBCI_ZONA { get; set; }

        [RequiredLocalized]
        [StringLength(3)]
        public string sUBCI_ESTANTERIA { get; set; }

        [RequiredLocalized]
        [StringLength(3)]
        public string sUBCI_PROFUNDIDAD { get; set; }

        [RequiredLocalized]
        [StringLength(2)]
        public string sUBCI_ALTURA { get; set; }

        [RequiredLocalized]
        [StringLength(50)]
        public string sUBCI_CODIGOART { get; set; }

        [Column(TypeName = "numeric")]
        public decimal iUBCI_CANTIDAD { get; set; }

        public DateTime iUBCI_FECHAALM { get; set; }

        public List<UBCI> Listar()
        {
            var inventario = new List<UBCI>();
            try
            {
                using (var context = new SGAContext())
                {
                    inventario = context.UBCI
                        .ToList();
                }
            }
            catch (Exception e)
            {
                throw new Exception(e.Message);
            }
            return inventario;
        }

        public UBCI Obtener(int codigo)
        {
            var articulo = new UBCI();
            try
            {
                using (var context = new SGAContext())
                {
                    articulo = context.UBCI
                        .Where(x => x.id == codigo)
                        .Single();
                }
            }
            catch (Exception e)
            {
                throw new Exception(e.Message);
            }
            return articulo;
        }

        public void Guardar()
        {
            try
            {
                using (var context = new SGAContext())
                {
                    if (this.id == 0)
                    {
                        context.Entry(this).State = System.Data.Entity.EntityState.Added;
                    }
                    else
                    {
                        context.Entry(this).State = System.Data.Entity.EntityState.Modified;
                    }

                    context.SaveChanges();
                }
            }
            catch (Exception e)
            {
                throw new Exception(e.Message);
            }
        }

        public void Eliminar(int codigo)
        {
            try
            {
                using (var context = new SGAContext())
                {
                    context.Entry(new UBCI { id = codigo }).State = System.Data.Entity.EntityState.Deleted;
                    context.SaveChanges();
                }
            }
            catch (Exception e)
            {
                throw new Exception(e.Message);
            }
        }
    }
}
