namespace SGA.Models
{
    using System;
    using System.Collections.Generic;
    using System.ComponentModel.DataAnnotations;
    using System.ComponentModel.DataAnnotations.Schema;
    using System.Data.Entity.Spatial;
    using System.Linq;

    [Table("UBCZ")]
    public partial class UBCZ
    {
        [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Usage", "CA2214:DoNotCallOverridableMethodsInConstructors")]
        public UBCZ()
        {
            UBCM = new HashSet<UBCM>();
        }

        [DatabaseGenerated(DatabaseGeneratedOption.Identity)]
        public int id { get; set; }

        [Key]
        [Column(Order = 0)]
        [StringLength(2)]
        public string sUBCZ_ALMACEN { get; set; }

        [Key]
        [Column(Order = 1)]
        [StringLength(2)]
        public string sUBCZ_ZONA { get; set; }

        public int sUBCZ_ORDENACION { get; set; }

        public virtual UBCA UBCA { get; set; }

        [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Usage", "CA2227:CollectionPropertiesShouldBeReadOnly")]
        public virtual ICollection<UBCM> UBCM { get; set; }

        public List<UBCZ> ObtenerPorAlmacen(string almacen)
        {
            var zonas = new List<UBCZ>();
            try
            {
                using (var context = new SGAContext())
                {
                    context.Configuration.LazyLoadingEnabled=false;
                    //Se desactiva lazyloading para que no haya problemas con la muerte del contexto al llegar al procesamiento en jQuery
                    zonas = context.UBCZ
                        .Where(x => x.sUBCZ_ALMACEN == almacen).ToList();
                }
            }
            catch (Exception e)
            {
                throw new Exception(e.Message);
            }
            return zonas;
        }

        public int ObtenerOrdenacion(string almacen, string zona)
        {
            UBCZ ordenacion;
            try
            {
                using (var context = new SGAContext())
                {
                    context.Configuration.LazyLoadingEnabled = false;
                    //Se desactiva lazyloading para que no haya problemas con la muerte del contexto al llegar al procesamiento en jQuery
                    ordenacion = context.UBCZ
                        .Where(x => x.sUBCZ_ALMACEN == almacen && x.sUBCZ_ZONA == zona).Single();
                }
            }
            catch (Exception e)
            {
                throw new Exception(e.Message);
            }
            return ordenacion.sUBCZ_ORDENACION;
        }

        public void Guardar()
        {
            try
            {
                using (var context = new SGAContext())
                {
                    if (this.id == 0)
                    {
                        context.Entry(this).State = System.Data.Entity.EntityState.Added;
                    }
                    else
                    {
                        context.Entry(this).State = System.Data.Entity.EntityState.Modified;
                    }

                    context.SaveChanges();
                }
            }
            catch (Exception e)
            {
                throw new Exception(e.Message);
            }
        }
    }
}
