namespace SGA.Models
{
    using Insya.Localization.Attributes;
    using System;
    using System.Collections.Generic;
    using System.ComponentModel.DataAnnotations;
    using System.ComponentModel.DataAnnotations.Schema;
    using System.Data.Entity.Spatial;
    using System.Linq;

    [Table("ZONA")]
    public partial class ZONA
    {
        [DatabaseGenerated(DatabaseGeneratedOption.Identity)]
        public int id { get; set; }

        [Key]
        [Column(Order = 0)]
        [RequiredLocalized]
        [StringLength(2)]
        public string sZONA_id { get; set; }

        [Key]
        [Column(Order = 1)]
        [RequiredLocalized]
        [DatabaseGenerated(DatabaseGeneratedOption.None)]
        public int sZONA_TIPO { get; set; }

        public List<ZONA> Listar()
        {
            var zonas = new List<ZONA>();
            try
            {
                using (var context = new SGAContext())
                {
                    zonas = context.ZONA.ToList();
                }
            }
            catch (Exception e)
            {
                throw new Exception(e.Message);
            }
            return zonas;
        }

        public List<ZONA> ListarTipo(int tipo)
        {
            var zonas = new List<ZONA>();
            try
            {
                using (var context = new SGAContext())
                {
                    zonas = context.ZONA
                        .Where(x=> x.sZONA_TIPO == tipo)
                        .ToList();
                }
            }
            catch (Exception e)
            {
                throw new Exception(e.Message);
            }
            return zonas;
        }

        public ZONA Obtener(int id)
        {
            var zone = new ZONA();
            try
            {
                using (var context = new SGAContext())
                {
                    zone = context.ZONA
                        .Where(x => x.id==id)
                        .Single();
                }
            }
            catch (Exception e)
            {
                throw new Exception(e.Message);
            }
            return zone;
        }

        public void Guardar()
        {
            try
            {
                using (var context = new SGAContext())
                {
                    if (this.id == 0)
                    {
                        context.Entry(this).State = System.Data.Entity.EntityState.Added;
                    }
                    else
                    {
                        context.Entry(this).State = System.Data.Entity.EntityState.Modified;
                    }

                    context.SaveChanges();
                }
            }
            catch (Exception e)
            {
                throw new Exception(e.Message);
            }
        }

        public void Eliminar(string codigo, int tipo)
        {
            try
            {
                using (var context = new SGAContext())
                {
                    context.Entry(new ZONA { sZONA_id = codigo , sZONA_TIPO = tipo }).State = System.Data.Entity.EntityState.Deleted;
                    context.SaveChanges();
                }
            }
            catch (Exception e)
            {
                throw new Exception(e.Message);
            }
        }
    }
}
